!- =============================================================================
!- POOYAN16 4KB v0.6 by Giuseppe Mignogna 2019
!- =============================================================================
!- Sorgente per C16 scritto usando CBM prg Studio 3.13
!- =============================================================================

!- 100 REM POOYAN16 4KB - v0.6 - Giuseppe Mignogna - April 2019

!- =============================================================================
!- MAIN                                                     
!- =============================================================================
!-  MS = max sprites, SR = sprite array, SC = score, LV = lives
500 MS=8:DIMSR(MS,30):SC=0:LV=3
!-  Per non cancellare il punteggio, rieseguire da 510
!-  I, SI, SX, SZ = for index, FC = frame counter, SP = sprite type
!-  WH = wolves hit counter, WU = wolves up, DV = data value, GS = game status
510 I=0:SI=0:SX=0:SZ=0:FC=0:SP=0:CL=2048:SL=3072
520 WH=30:WU=0:DV=0:NN=9:ND=10:NU=11:NV=20:GS=0

!-  Inizializza sprite Mama pig
530 SI=0:SP=5:GOSUB4400:SR(1,9)=0:SR(1,7)=32
!-  535 VOL8
540 GOSUB9000:GOSUB4200:CHAR1,10,12,"                  ":GOSUB6000

!- Loop principale partita
600 GOSUB3000

!-  Aggiorna frame counter
610 FC=FC+1:IFFC<12THEN700
!-  Se lo stato del gioco è diverso da zero, esegue azione
615 IFGS<>0THEN4100
!-  Compie azioni diverse a seconda del numero casuale
620 FC=0:ON(RND(1)*10)GOTO640,650,660
630 GOTO700
!-  Fa comparire un lupo; se non trova uno slot libero, ritorna SI=0,
!-  per cui non c'è bisogno di fare controlli in quanto una modifica
!-  allo sprite 0 non ha effetti (non viene usato)
640 SI=0:SP=1:GOSUB4400:SR(SI,13)=INT(RND(1)*19+6):GOTO700
!-  Fa scendere una ghianda
650 SI=0:SP=10:GOSUB4400:SR(SI,ND)=INT(RND(1)*19+6):GOTO700
!-  Fa lanciare frutto al lupo
660 FORI=5TO8:IFSR(I,1)<>2THEN680
662 IFSR(I,11)<8THEN680
665 SI=0:SP=9:GOSUB4400:SR(SI,ND)=SR(I,ND):SR(SI,NU)=SR(I,NU)+1:I=8
680 NEXT:GOTO700
!- Gestione tasti
!-  Nessun tasto 
700 IFPEEK(198)=64THEN600
!-  Spazio
710 IFPEEK(198)=60THENSI=0:SP=6:GOSUB4400:SR(SI,NU)=SR(1,NU):GOTO600
!-  ^^ TODO: Aggiungere ricalcolo dell'offset in base alla nuova coord. Y
!-  Return
720 IFPEEK(198)=1THENSI=0:SP=11:GOSUB4400:SR(SI,NU)=SR(1,NU):GOTO600
!-  ^^ TODO: Aggiungere ricalcolo dell'offset in base alla nuova coord. Y
!-  Su
730 IFPEEK(198)=43THENIFSR(1,NU)<>8THENSR(1,NU)=SR(1,NU)-1:SR(1,7)=32:SR(1,6)=92
!-  Giù
740 IFPEEK(198)=40THENIFSR(1,NU)<>21THENSR(1,NU)=SR(1,NU)+1:SR(1,7)=72:SR(1,6)=92
800 GOTO600
!- =============================================================================



!- SUB Elaborazione sprite 
!- I = sprite index, MN = frame counter module, OF = old offset
!- Nota: a volte crea un glitch, l'algoritmo corretto sarebbe:
!- 1) ridisegnare gli sfondi vecchi in ordine decrescente;
!- 2) aggiornare x,y;
!- 3) memorizare gli sfondi nuovi in ordine crescente;
!- 4) disegnare gli sprite;
!- 5) loop a 1.
!- Tutti gli inserimenti/eliminazioni di sprite dovrebbero avvenire nel loop:
!- se si sta inserendo un nuovo sprite, lo sfondo vecchio non va disegnato;
!- se si sta eliminando uno sprite, lo sprite non va disegnato (alg. da verificare).
!- Altro metodo sarebbe quello di ridisegnare sempre tutto lo sfondo e 
!- gli sprite, o di avere una copia dello sfondo da cui recuperare i dati.
3000 FORI=1TOMS
!-   Se il tipo di sprite è nullo, passa al prossimo sprite
3110 IFSR(I,1)=0THEN3600
!-   Se frameCounter MOD frameTrigger <> 0, passa al prossimo sprite
3120 MN=FC/SR(I,22):IFMN<>INT(MN)THEN3600
!-   Salva l'offset e aggiorna X,Y
3140 OF=SR(I,NN):SR(I,ND)=SR(I,ND)+SR(I,18):SR(I,NU)=SR(I,NU)+SR(I,19)
!-   Memorizza nuovo screen offset; confronta vecchio e nuovo offset: se 
!-   non c'è stato movimento, salta al prossimo sprite
3150 SR(I,NN)=SR(I,ND)+SR(I,NU)*40:IFSR(I,NN)=OFTHEN3600
!-   Ripristina carattere dello sfondo vecchio (=32, se sta nella zona di hit)
3170 IFSR(I,ND)<31ANDSR(I,NU)>7THENPOKESL+OF,32:ELSEPOKESL+OF,SR(I,7)
!-   Ripristina vecchio colore; salva colore e carattere dello sfondo nuovo
3180 POKECL+OF,SR(I,6):SR(I,6)=PEEK(CL+SR(I,NN)):SR(I,7)=PEEK(SL+SR(I,NN))
!-   Disegna lo sprite (colore e carattere)
3185 POKECL+SR(I,NN),SR(I,2):POKESL+SR(I,NN),SR(I,4)
!-   Verifica collisioni: confronta il carattere di sfondo con i due 
!-   che causano una collisione
3410 IFSR(I,7)=SR(I,23)ORSR(I,7)=SR(I,24)THENGOSUB3800
!-   Controlla se è stata raggiunta una posizione limite 
3500 IFSR(I,ND)=SR(I,12)ORSR(I,ND)=SR(I,13)THENGOSUB4000:GOTO3600
3520 IFSR(I,NU)=SR(I,14)ORSR(I,NU)=SR(I,15)THENGOSUB4000
!-   Fine ciclo sprite
3600 NEXT 
3700 RETURN


!- SUB Esecuzione action script collisione
!- SZ = index of hit sprite 2, SI = param 1, SP = param 2
!- Nota: il metodo migliore sarebbe quello di confrontare le coordinate
!- di ogni sprite-arma con ogni sprite-bersaglio, ma è troppo oneroso.
!- TODO: dividire sprite in neutri, arma e bersagli
!-   Cerca indice sprite che ha causato collisione
3800 FORSZ=1TOMS
!-   Hanno lo stesso screen offset?
3805 IFSR(SZ,NN)<>SR(I,NN)THEN3830
!-   E' uno sprite nullo?
3810 IFSR(SZ,1)=0THEN3830
!-   Il carattere è uno di quelli previsiti per l'hit?
3815 IFSR(SZ,4)<>SR(I,23)ANDSR(SZ,4)<>SR(I,24)THEN3830
!-   Sicuramente ha colpito uno sprite "giusto", quindi esegue l'azione associata
!-   (usa il gosub in modo da togliere il for dallo stack al ritorno)
3820 ONSR(I,27)GOSUB3840,3860
!-   Fa terminare il ciclo, non serve continuarlo
3825 SZ=MS
3830 NEXT:RETURN
!- Subroutines gestione tipi di collisioni
!-   1: Lupo (che scende) o ghianda colpiti
3840 SC=SC+SR(I,25)*SR(SZ,25):GOSUB6000
!- Se ha colpito un lupo, diminuisce il contatore WH. Se WH=0, lo stato del
!- gioco GS viene impostato ad 1 (livello terminato)
3841 IFSR(I,1)=2ORSR(SZ,1)=2THENWH=WH-1:GOSUB6000:IFWH=0THENGS=1
!-   Annulla il primo sprite
3843 SR(I,1)=0:POKESL+SR(I,NN),32
!-   Converte secondo sprite in uno sprite punteggio
3845 SI=SZ:SP=8:GOSUB4400:SR(SZ,14)=SR(SZ,11)-3
3855 RETURN
!-   2: Mama pig colpita
3860 LV=LV-1:GOSUB6000:IFLV=0THENGS=2
3870 RETURN


!- SUB Esecuzione action script posizione limite
!- INPUT: I = sprite index
!- SI = param 1, SP = param 2
4000 ONSR(I,26)GOTO4020,4030,4040,4050,4060,4070,4080
4015 RETURN
!-   1: Cambia lo sprite nello sprite seguente
4020 SI=I:SP=SR(I,28):GOSUB4400:RETURN     
!-   2: Inverte delta X
!-   4030 SR(I,18)=-SR(I,18):RETURN
4030 RETURN
!-   3: Inverte delta Y
!-   4040 SR(I,19)=-SR(I,19):RETURN
4040 RETURN
!-   4: Annulla lo sprite senza cancellarlo
4050 SR(I,1)=0:RETURN
!-   5: Annulla lo sprite e lo cancella
4060 SI=I:GOSUB4300:RETURN
!-   6: Gestisce lupo fermo sulle scale
!-   TODO: bug fix: dovrebbe aggiornare la Y limite (14) di eventuali altri 
!-   lupi che stanno già salendo le scale
4070 SR(I,1)=0:WU=WU+1:IFWU=4THENGS=2
4075 RETURN     
!-   7: Gestisce lupo che sale scale
4080 SI=I:SP=SR(I,28):GOSUB4400
4090 SR(SI,14)=20-WU*4:RETURN    


!- Gestione stato gioco
!- GS=0: ignored, GS=1: level completed, GS=2: game over 
4100 POKE239,0:ONGSGOTO4110,4120
4110 FORSX=1TOMS:SR(SX,1)=0:NEXT:CHAR1,13,12,"bravo gianni!":GOSUB4200:GOTO510
4120 CHAR1,15,12,"game over":GOSUB4200:RUN


!- SUB Aspetta pressione spazio
4200 GETKEYS1$:IFS1$<>" "THEN4200
4210 RETURN


!- SUB Annulla e cancella sprite
!- INPUT: SI = sprite index
4300 SR(SI,1)=0:POKECL+SR(SI,NN),SR(SI,6):POKESL+SR(SI,NN),SR(SI,7):RETURN


!- Sprite slot:
!-       0: null
!-       1: mama
!-     2,3: arrow or bone
!-       4: wolf's fruit
!- 5,6,7,8: wolf, acorn or score
!-
!- SUB Assegnazione sprite
!- INPUT: SI = sprite index, SP = sprite type (1, ...)
!- DV = data value, SX = FOR index, FS = for start, FE = for end
4400 IFSI>0THEN4480
!- Nuovo sprite, cerca uno slot vuoto (sprite type = 0);
!- l'intervallo di ricerca è diverso a seconda dello sprite
!- TODO: caricare i dati dei tipi di sprite in un array
4410 RESTORE8001+(SP-1)*2:READFS,FE:RESTORE8000+(SP-1)*2
4420 FORSX=FS TO FE:IFSR(SX,1)=0THENSI=SX:SX=MS
4440 NEXT:IFSI=0THENRETURN
!-   Essendo un nuovo sprite, legge tutti gli attributi e memorizza lo sfondo
4460 FORSX=1TO30:READDV:SR(SI,SX)=DV:NEXT
4462 SR(SI,NN)=SR(SI,ND)+SR(SI,NU)*40
4465 SR(SI,6)=peek(CL+SR(SI,NN))
4470 SR(SI,7)=peek(SL+SR(SI,NN))
4475 RETURN
!- Sprite esistente, non sovrascrive alcuni attributi
4480 RESTORE8000+(SP-1)*2
4485 FORSX=1TO30:READDV
4490 IFSX<6ORSX>11THENSR(SI,SX)=DV
4500 NEXT
!- 4550 GOSUB5000
4600 RETURN


!- SUB Esegue effetto sonoro
!- INPUT: SI = sprite index
!- 5000 ONSR(SI,29)GOTO5010
!- 5005 RETURN
!- 5010 SOUND1,400,3:RETURN


!- SUB Stampa score, vite, ecc.
6000 CHAR1,5-LEN(STR$(WH)),1,STR$(WH):CHAR1,14,0,STR$(SC):CHAR1,29,0,STR$(LV)
6010 RETURN


!- Proprietà dello sprite:
!-  01: sprite type  (0 = null)
!-  02: sprite color
!-  03: (unused)
!-  04: sprite character
!-  05: (unused)
!-  06: background color
!-  07: background character
!-  08: (unused)
!-  09: screen offset
!-  10: x
!-  11: y
!-  12: x min
!-  13: x max
!-  14: y min
!-  15: y max
!-  
!-  16: min sprite slot index
!-  17: max sprite slot index
!-  18: delta X      (-1, 0, +1)
!-  19: delta Y      (-1, 0, +1)
!-  20: (unused)
!-  21: (unused)
!-  22: frame trigger
!-  23: hit character 1
!-  24: hit character 2
!-  25: hit points
!-  26: position reached action 
!-  27: hit action
!-  28: next sprite type
!-  29: sound fx
!-  30: (unused)
!-
!- DATA definizione tipi di sprite
!-   Tipo 1 - Lupo va a destra (top)
8000 DATA 1,104,0,94,0,0,0,0,0,0,3,0,25,50,50
8001 DATA 5,8,1,0,0,0,8,0,0,100,1,0,2,0,0
!-   Tipo 2 - Lupo scende
8002 DATA 2,104,0,94,0,0,0,0,0,0,0,50,50,0,23
8003 DATA 5,8,0,1,0,0,12,45,121,100,1,1,3,0,0
!-   Tipo 3 - Lupo va a destra (bottom)
8004 DATA 3,104,0,94,0,0,0,0,0,0,0,0,33,50,50
8005 DATA 5,8,1,0,0,0,4,121,0,100,7,1,4,0,0
!-   Tipo 4 - Lupo sale scala
8006 DATA 4,104,0,94,0,0,0,0,0,0,0,50,50,15,24
8007 DATA 5,8,0,-1,0,0,8,0,0,100,6,0,0,0,0
!-   Tipo 5 - Mama
8008 DATA 5,91,0,65,0,0,0,0,0,31,8,50,50,8,22
8009 DATA 1,1,0,0,0,0,1,90,0,0,0,2,0,0,0
!-   Tipo 6 - Freccia
8010 DATA 6,113,0,45,0,0,0,0,0,30,8,5,50,50,50
8011 DATA 2,3,-1,0,0,0,1,94,88,1,5,1,0,0,0
!-   Tipo 8 - Punteggio 
8014 DATA 8,119,0,36,0,0,0,0,0,0,0,50,50,2,50
8015 DATA 5,8,0,-1,0,0,2,0,0,100,5,0,0,0,0
!-   Tipo 9 - Frutto dal lupo
8016 DATA 9,118,0,90,0,0,0,0,0,0,0,0,31,50,50
8017 DATA 4,4,1,0,0,0,1,65,0,100,5,2,0,0,0
!-   Tipo 10 - Ghianda
8018 DATA 10,99,0,88,0,0,0,0,0,0,6,50,50,0,23
8019 DATA 5,8,0,1,0,0,8,45,121,200,5,1,0,0,0
!-   Tipo 11 - Osso scende
8020 DATA 11,119,0,121,0,0,0,0,0,30,8,5,50,7,23
8021 DATA 2,3,-1,1,0,0,1,94,88,2,1,1,12,0,0
!-   Tipo 12 - Osso sale
8022 DATA 12,119,0,121,0,0,0,0,0,30,8,5,50,7,23
8023 DATA 2,3,-1,-1,0,0,1,94,88,2,5,1,0,0,0


!- SUB Disegna schermata
!- SX = FOR index, S0$ S1$ S5$ S7$ = temp strings
9000 S1$="{reverse on}     {reverse off}                            "
9002 S5$="{reverse on}     ":S7$="{reverse on}       ":S0$="          "
9003 SCNCLR:COLOR0,7,4:COLOR4,7,2
9005 PRINT" {dark gray}{176}CCC{174}{yellow}   score          lives"
9010 PRINT" {dark gray}B{pink}   {dark gray}B"
9020 PRINT" {171}CCC{189}";S0$;S0$;"     {gray}W{brown}PM {dark gray}QQ"
9030 PRINT" B";S0$;S0$;"         {gray}H{brown}{170} M{gray}AA"
9040 PRINT"{light gray}";S7$;S7$;S7$;S5$;"{127}{reverse off}    {gray}H{light gray}{167}";S7$
9050 PRINT"{light gray}";S5$;S5$;S5$;S5$;S5$;" {reverse off}{169}    {gray}H{orange}{160}";S7$
9060 PRINT"{light gray}";S5$;S5$;S5$;S5$;"{reverse off}{169}";S0$;"{gray}H {orange}";S7$
9070 PRINT"{light gray}";S5$;"{reverse off}{169}";S0$;S0$;"     {gray}H {orange}";S7$
9075 FORSX=0TO3
9080 PRINTS1$;"{yellow}{171}{179}{orange}";S5$
9090 PRINTS1$;"{yellow}{171}{179}{orange}";S5$
9100 PRINTS1$;S7$
9110 PRINTS1$;S7$
9120 NEXT
9240 PRINTS5$;"{127}{reverse off}{light gray}";
9250 FORSX=0TO26:PRINT"{168}";:NEXT:PRINT"{reverse on}{orange} gm'19{reverse off}";
9260 POKE4071,160:COLOR1,9,6:CHAR1,10,12,"pooyan16 ...in 4k!":RETURN











